<?php
/**
 * WP-CDN-Yes 其他
 * @author 耗子
 * @created 2020-12-20
 * @updated 2021-10-17
 */

defined('ABSPATH') || exit;
if (!class_exists('WPCDN_Other')):
    class WPCDN_Other
    {

        private $settings_api;
        private $wpcy_cdn_static;
        private $wpcy_change_cache_control;

        function __construct()
        {
            // 设置API
            $this->settings_api = new Easy_Setting;
            $this->wpcy_cdn_static = $this->settings_api->get_option('wpcy_cdn_static', 'wpcy_advanced');
            $this->wpcy_change_cache_control = $this->settings_api->get_option('wpcy_change_cache_control', 'wpcy_advanced');

            // 静态加速
            if ($this->wpcy_cdn_static == 'on') {
                self::cdn_static();
            }

            // 修改cache-control
            if ($this->wpcy_change_cache_control == 'on') {
                self::change_cache_control();
            }
        }

        function cdn_static()
        {
            add_action('template_redirect', function () {
                ob_start(function ($content) {
                    $regex = '#(?<=[(\"\'])(?:' . quotemeta(home_url()) . ')?/(?:((?:wp-content|wp-includes)[^\"\')]+\.(css|js)[^\"\')]+))(?=[\"\')])#';

                    return preg_replace_callback($regex, function (&$asset) {
                        $hurl = str_replace(array('https://', 'http://'), '', home_url());
                        if (is_ssl()) {
                            $cdn_url = 'public-cdn-ssl.wp-cdn.cn/' . $hurl;
                        } else {
                            $cdn_url = 'public-cdn.wp-cdn.cn/' . $hurl;
                        }
                        return str_replace($hurl, $cdn_url, $asset[0]);
                    }, $content);

                });
            });
        }

        function change_cache_control()
        {
            add_action('template_redirect', function () {
                header("cache-control: public");
            });
        }
    }
endif;
